# 🚀 Linear - Your Ultimate Coding Contest Companion

![Coding Contest](https://img.shields.io/badge/Platform-CLI-blue?style=for-the-badge)
![Python](https://img.shields.io/badge/Python-3.6+-yellow?style=for-the-badge&logo=python)
![License](https://img.shields.io/badge/License-MIT-green?style=for-the-badge)

> **"Efficiency is doing better what is already being done."** - Peter Drucker  
> Linear helps you do competitive programming better by automating the mundane!

## 🌟 Introduction

Linear is your **Python-powered Swiss Army knife** for coding contests! Designed with ❤️ for competitive programmers, it streamlines your workflow by providing quick access to AtCoder/Codeforces resources, generating code templates, and visualizing rating progress - all from your terminal!

```bash
 /$$       /$$
| $$      |__/
| $$       /$$ /$$$$$$$   /$$$$$$   /$$$$$$   /$$$$$$
| $$      | $$| $$__  $$ /$$__  $$ |____  $$ /$$__  $$
| $$      | $$| $$  | $$| $$_____/ /$$__  $$| $$
| $$$$$$$$| $$| $$  | $$|  $$$$$$$|  $$$$$$$| $$
|________/|__/|__/  |__/ \_______/ \_______/|__/
```

## 🎯 Features

### 🏁 Contest Navigation

- ⚡ **Lightning-fast access** to AtCoder resources:
  - 🏠 Home page | 🏆 Contests | 📊 Rankings
  - 👤 User profiles | 🎮 Specific contests
  - 📝 Tasks | 📤 Submissions | 🏅 Standings

### 💻 Code Generation

```cpp
// Automatically generated template
#include <bits/stdc++.h>
using namespace std;
// Your competitive edge starts here...
```

### 📈 Rating Visualization

![UI](https://github.com/user-attachments/assets/2ac5d7e3-8983-4843-b90d-9fe19bdc117d)

### ⏱️ Plus More

- 🕒 Current time display
- ❓ Helpful documentation
- 💖 About section with support info

## 🛠️ Installation

1. **Clone the repository**:

   ```bash
   git clone https://github.com/Linus-Shyu/Linear.git && cd Linear
   ```

2. **Run the tool**:

   ```bash
   python Linear_0.0.4.py
   ```

## 🎮 Usage Examples

| Command  | Action                 | Example           |
| -------- | ---------------------- | ----------------- |
| `play`   | Open specific contest  | `abc123`          |
| `task`   | View problem statement | `abc123 A`        |
| `code`   | Generate C++ templates | `username abc123` |
| `rating` | Show CF rating graph   | `tourist`         |
| `time`   | Display current time   |                   |

```bash
# Try it yourself!
$ python Linear_0.0.4.py
Linear> rating tourist
Fetching Codeforces data...
Displaying rating graph...
```

## 🤝 Contributing

We welcome contributions! Here's how you can help:

1. 🐛 Report bugs via [GitHub Issues](https://github.com/Linus-Shyu/Linear/issues)
2. 💡 Suggest new features
3. 🛠️ Submit pull requests

## 📜 License

MIT © [Linus Shyu](https://github.com/Linus-Shyu)  
_"Sharing knowledge is the most fundamental act of friendship."_

## 💌 Connect

Let's build the competitive programming community together!

[![GitHub](https://img.shields.io/badge/GitHub-Linear-blue?style=flat&logo=github)](https://github.com/Linus-Shyu/Linear)
[![Bilibili](https://img.shields.io/badge/BiliBili-LinusShyu-red?style=flat)](https://space.bilibili.com/411591950)
[![YouTube](https://img.shields.io/badge/YouTube-@LinusShyu-red?style=flat&logo=youtube)](https://www.youtube.com/@LinusShyu)

💖 **Support the project** via WeChat Pay (QR code available in the `about` command)
